#pragma once

class InterrogableTessellationSink : public ID2D1TessellationSink
{
private:
    LONG m_refCount;
    std::vector<D2D1_TRIANGLE> m_triangles;

public:
    InterrogableTessellationSink();

    // IUnknown methods
    virtual ULONG STDMETHODCALLTYPE AddRef() override;
    virtual ULONG STDMETHODCALLTYPE Release() override;
    virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void **ppvObject) override;

    // ID2D1Tessellation methods
    virtual void STDMETHODCALLTYPE AddTriangles(_In_ const D2D1_TRIANGLE *triangles, UINT trianglesCount) override;
    virtual HRESULT STDMETHODCALLTYPE Close() override;

    // Method for this implementation
    std::vector<D2D1_TRIANGLE> GetTriangles();
};
